#ifndef _PACKAGE_H
#define _PACKAGE_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define DfltBufferSize 1048576
#define ExtraSize      (512 * 1024)
#define HARDCHECKSUM   9841478
#define HASHKEYLEN     512
#define CHECKSUMLEN    1024
#define CRYPTMETHOD    CIPHERUSERSKEY

#define CRYPT_ALGO_NASCCL   0
#define CRYPT_ALGO_RIJNDAEL 1
#define CRYPT_ALGO_BLOWFISH 2

#define OPTION_COMPRESSION 0x0001
#define OPTION_DATETIME    0x0002
#define OPTION_CRCCHECK    0x0004
#define OPTION_SAVEPATHS   0x0010
#define OPTION_ATTRIBUTES  0x0020

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool BreakPackage(char *SrcName, char *TarFolder, char *RawKey, int RawKeyLen);
bool MakePackage(char *SrcFolder, char *TarName, char *RawKey, int RawKeyLen, int PkgAttribs);
bool PopGrid(char *SrcName, char *RawKey, int RawKeyLen);
bool TestPackage(void);
DWORD WINAPI CreateFileArchive_Worker_Thread(LPVOID xData);
DWORD WINAPI CreateNewDirArchive_Worker_Thread(LPVOID xData);
DWORD WINAPI ViewExisting_Worker_Thread(LPVOID xData);
DWORD WINAPI ExtractEntireArchive_Worker_Thread(LPVOID xData);
long MakeChecksum(char *RawKey);
void CreateFolderStructure(char *FullFileName);

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

extern DWORD dwPackageProgress;

extern DWORD dwWorker_Thread_ID;
extern  HANDLE hWorker_Thread_Handle;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
